package org.eclipse.stp.b2j.core.publicapi;

import org.eclipse.core.runtime.Platform;

public class WorkbenchClassLoader {
	public static Class loadClassFrom(String classname, String plugin) throws Exception {
		return Platform.getBundles(plugin,null)[0].loadClass(classname);
	}
	public static Class loadClassFrom(String classname) throws Exception {
		String[] sections = classname.split("\\.");
		
		int n = sections.length;
		
		while (n > 0) {
			try {
				StringBuffer sb = new StringBuffer();
				for (int i = 0; i < n; i++) {
					sb.append(sections[i]);
					if (i < n-1) {
						sb.append('.');
					}
				}
				
				return Platform.getBundles(sb.toString(),null)[0].loadClass(classname);
			} catch (Exception e) {
			}
			
			n--;
		}
		throw new Exception("Could not load class "+classname+" based on any plugin composed of its subpackages");
	}
}
